import React, { Component } from 'react';
import {Sensor,Data} from './model.js' 
import { Link } from 'react-router-dom';
import mqtt from 'mqtt';
import {BrowserRouter as Router,Route, Redirect} from 'react-router-dom'
import './App.css';

// Print sensors with there name and value
class Composants extends React.Component
{
	render(){
        // get last 10 sensor values
        let sensors_values = this.props.capteur.data.values.slice(Math.max(this.props.capteur.data.values.length - 10, 1));
        // Print sensor values
        const values = sensors_values.map(function(v)
        {
            if (Number(v)){
                return  <tr><td class="td_historique">{Number(v).toFixed(3)}</td></tr>
            }else{
                return  <tr><td class="td_historique">{v}</td></tr>
            }
    
        });
         

        // Get current value of sensor
        var Last_val;
		if (Number(this.props.capteur.data.getlastValues())){
			Last_val = parseFloat(this.props.capteur.data.getlastValues()).toFixed(3);
		}else{
			Last_val = this.props.capteur.data.getlastValues();
        }	
        
        if(this.props.capteur.type === "TEMPERATURE"){
            Last_val += " °";
        }else if(this.props.capteur.type === "PERCENT"){
            Last_val += " %";
        }else if(this.props.capteur.type === "ON_OFF"){
            Last_val += " (ON/OFF)";
        }

        var name_sensor;
        if(this.props.capteur.name === "temperatureChambre"){
            name_sensor = "Temperature de la chambre";
        }else if(this.props.capteur.name === "temperatureSalleA111"){
            name_sensor = "Temperature de la Salle A111";
        }else if(this.props.capteur.name === "MonAttention"){
            name_sensor = "Mon attention";
        }else if(this.props.capteur.name === "MesYeux"){
            name_sensor = "Mes yeux";
        }
    
        // valeur actuelle du capteur
		return (
			<div>
					<h2> {name_sensor + " || " + " Type du capteur : "+this.props.capteur.type+""}</h2>
					<div>
						<div>
							<h3 >Valeur actuelle : {Last_val}</h3>							
						</div>
					</div>
                    <div>
                        <h3>Historique</h3>
                        {values}
                    </div>  
			</div>
			
		);
	}
}

// Print left list
class Sensors extends React.Component{
  render(){
       
      const btnTempChambre = <li> <Link to={`/temperatureChambre`}><button>Temperature de la Chambre</button></Link></li>;
      const btnSalle = <li> <Link to={`/temperatureSalleA111`}><button>Temperature Salle A111</button></Link></li>
      const btnAttention = <li> <Link to={`/MonAttention`}><button>Mon Attention</button></Link></li>
      const bntYeux = <li> <Link to={`/MesYeux`}><button>Mes Yeux</button></Link></li>;

      return (
          <ul>
            {btnTempChambre}
            {btnSalle}
            {btnAttention}
            {bntYeux}
          </ul>
      );
  }
}

var user_mqtt = mqtt.connect('mqtt://127.0.0.1:8080')


user_mqtt.on('connect', function () {
    user_mqtt.subscribe('#')
})

let liste_Sensor = [];
function Liste_Sensors(name, list){
 var i;
  for (i = 0; i < list.length; i++) {
      if (list[i].name === name) {
          return list[i];
      }
  }
}

class App extends Component {
  constructor(props) {

    super(props); 
    this.sensor = null;
    this.state = {value: '',list: []};
    this.handleChange = this.handleChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
    this.rendom_app_sensor();
  }

  handleChange(event) {
    this.setState({value: "/"+event.target.value});
  }
  
  handleSubmit(event) {
    return <Redirect to="" />;    
  }
  
  rendom_app_sensor(){
    let Liste_resultat = this;
    user_mqtt.on('message', function (topic, message) { 
        var Json = JSON.parse(message.toString());
        var name_sen = topic.substring(6);
        var val_sen = Json['value'];        
        var type_Sen = Json['type'] 
        var donnees = new Data([val_sen]);
        var Sen= new Sensor(name_sen,type_Sen,donnees); 
          liste_Sensor.push(Sen);
          Sen=Liste_Sensors(name_sen,liste_Sensor);
          Array.prototype.push.apply(Sen.data.values, [val_sen]);
                
          Liste_resultat.setState({list:liste_Sensor});
      });
  }
  State(name)
  {
    
    var i;
    for (i = 0; i < this.state.list.length; i++)
     {
        if (this.state.list[i].name === name) {
            return this.state.list[i];
        }
    }
  }
  render() {
    return (
      <Router>
      <div>
          <header><center>
            <form onSubmit={this.handleSubmit} action={this.state.value}> 
                URL du Broker : 
                <input type="text" onChange={this.handleChange} placeholder="Capteur"/>
                <input class="btn-v" type="submit" value=" Valider" />
            </form> 
            </center>
          </header>
          <div className="wrapper">
            <nav>
                <Sensors list={this.state.list}/>
            </nav>
            <article>
              <Route path="/:nameSensor" render={(props) => {return <Composants capteur={this.State(props.match.params.nameSensor)} /> }} />
            </article>
          </div>
       </div>
       </Router>
    );
  }
}

export default App;
